/////////////////////////////////////////////////////////
// EEPROM.c

#include "./USB/usb.h"
#include "HardwareProfile.h"
#include "EEPROM.h"

struct EEPROMData eepromData;

#define DISABLE_INTERRUPTS INTCON &= ~0x80
#define ENABLE_INTERRUPTS INTCON |= 0x80

/////////////////////////////////////////////////////////
unsigned char EEPROMRead(unsigned char addr)
{
	EEADR = addr;
	EECON1 = 0;
	EECON1 = 1;
	return EEDATA;
}

/////////////////////////////////////////////////////////
void EEPROMBlockRead(void *dest, unsigned char src, unsigned char len)
{
	while (len--)
	{
		*(unsigned char *) dest = EEPROMRead(src++);
		dest = (unsigned char *) dest + 1;
	}
}

/////////////////////////////////////////////////////////
void EEPROMWrite(unsigned char data, unsigned char addr)
{
	// Wait if there's a write in progress
	while (EECON1 & 2)
		;
	EEADR = addr;
	EEDATA = data;
	EECON1 = 0;
	EECON1 |= 4;
	DISABLE_INTERRUPTS;
	EECON2 = 0x55;
	EECON2 = 0xaa;
	EECON1 |= 2;
	ENABLE_INTERRUPTS;
}

/////////////////////////////////////////////////////////
void EEPROMBlockWrite(unsigned char dest, void *src, unsigned char len)
{
	while (len--)
	{
		EEPROMWrite(*(unsigned char *) src, dest++);
		src = (unsigned char *) src + 1;
	}
}

